import { NgModule } from '@angular/core';
import { CommonModule ,DatePipe} from '@angular/common';
import { ReportsRoutingModule } from './reports-routing.module';
import { SharedModule } from '../shared/shared.module';
import { ReportComponent } from './report/report.component';
import { ReportService } from './reports.service';
import { ChartsModule } from 'ng2-charts';
import { DemoMaterialModule } from '../demo-material-module';
import { NgbModule } from '@ng-bootstrap/ng-bootstrap';
import { TmobileComponent } from './tmobile/tmobile.component';
import { NgxPaginationModule } from 'ngx-pagination';
import { Ng2SearchPipeModule } from 'ng2-search-filter';
import { FormsModule } from '@angular/forms';
import { ReactiveFormsModule } from '@angular/forms';
import {DateFormatPipe} from './datepipe.pipe'
@NgModule({
  declarations:
  [
    ReportComponent,
    TmobileComponent,
    DateFormatPipe
  ],
  imports:
  [
    CommonModule,
    ReportsRoutingModule,
    ChartsModule,
    SharedModule,
    DemoMaterialModule,
    NgxPaginationModule,
    Ng2SearchPipeModule,
    NgbModule,
    FormsModule,
    ReactiveFormsModule,
    
  ],
  providers: 
  [
    ReportService,
    DatePipe
  ]
})
export class ReportsModule { }
